"""
    fenetres.py
"""
import os
import tkinter as tk
import json
import glob
import tkinter.messagebox as tkmsg
import string
import re

import polices

ALPHA = string.ascii_uppercase
DICO_NEW = {}
SAISIE = ""

LANGUAGES = {
    "EN": "English",
    "FR": "French",
    "DE": "German",
    "ES": "Spanish",
    "LA": "Latin",
    "IT": "Italian",
    "PT": "Portuguese",
    "SE": "Swedish",
    "NL": "Dutch",
    "AF": "Afrikaans",
    "??": "???",
}
DICT_CAR_SPEC = {
    "é":"e", "è":"e", "ê":"e", "ç":"c", "à":"a", "ù":"u", "î":"i",
    "ä":"a", "ë":"e", "ï":"i", "ö":"o", "ü":"u", "ÿ":"y", "ò":"o",
    "æ":"ae","œ":"oe","ñ":"n", "ì":"i", "í":"i", "á":"a", "ó":"o",
    "û":"u", "ú":"u", "ý":"y", "ô":"o", "ß":"sz",
}
LIST_CHALL = []
HEADER_CHALL = {}

if "DEBUG" in os.environ:
    DEBUG = True
else:
    DEBUG = False

#----------------- fonctions --------------------------------
def decode_utf(chaine):
    result = ""
    for car in chaine:
        if car.upper() in ALPHA:
            result += car
        else:
            if car.lower() in DICT_CAR_SPEC:
                result += DICT_CAR_SPEC[car.lower()]
            else:
                result += car
    return result

#------------------------- classes ------------------------------
class MyDialog:
    top = None
    def __init__(self, parent):
        global top
        self.mode_plain = True
        top = self.top = tk.Toplevel(parent)
        self.myHeader = tk.Frame(top)
        ma_police = polices.cree_police()
        self.mySwitch = tk.Button(self.myHeader, text = "Crypto/Plain", 
            font=ma_police, command=self.switch_mode)
        self.myLabel = tk.Label(self.myHeader, text='Enter a plain text',
             font=ma_police)
        self.mySwitch.pack(side='left', expand=True, fill='both', padx='20')
        self.myLabel.pack(side='left', expand=True, fill='both',padx='20')
        self.myHeader.pack()

        self.myTextBox = tk.Text(top, font=ma_police, width = 50, heigh = 9, )
        self.myTextBox.pack()

        self.myButtons = tk.Frame(top)
        self.myPPButtons = tk.Button(self.myButtons, text = 'From Clipboard',
            font=ma_police, command=self.from_clip)
        self.myPPButtons.pack(side='left', expand=True, fill='both', padx='20')
        self.mySubmitButton = tk.Button(self.myButtons, text='OK', 
            font=ma_police, command=self.send)
        self.mySubmitButton.pack(side='left', expand=True, fill='both',padx='20')
        self.myButtons.pack()
        self.top.grab_set()
        if "PLAIN" in DICO_NEW: del DICO_NEW["PLAIN"] 
        if "CRYPTO" in DICO_NEW: del DICO_NEW["CRYPTO"] 
        if DEBUG:
            print("--- Constructeur de MyDialog (instancie la fenetre de saisie")

    def from_clip(self):
        x = top.clipboard_get()
        x = decode_utf(x)
        if len(x) != 0:
            self.myTextBox.insert("1.0", x)
        
    def switch_mode(self):
        if self.mode_plain:
            self.mode_plain = False
            self.myLabel.configure(text='Enter a Cryptogram')
        else:
            self.mode_plain = True
            self.myLabel.configure(text='Enter a plain text')
        if DEBUG:
            print("--- MyDialog.switch_mode(): Mode_plain: ", self.mode_plain)
    
    def send(self):
        if self.mode_plain:
            DICO_NEW["PLAIN"] = (self.myTextBox.get(1.0,'end')).upper()
        else:
            DICO_NEW["CRYPTO"] = (self.myTextBox.get(1.0,'end')).upper()
        DICO_NEW["KEY_TYPE"] = "k0"
        DICO_NEW["METHOD"] = "aristocrat"
        self.top.destroy()

class FenetreSaisie:
    def __init__(self, parent, l_invite):
        top = self.top = tk.Toplevel(parent)
        ma_police = polices.cree_police()

        self.myLabel = tk.Label(top, text=l_invite, font=ma_police)
        self.myLabel.pack()

        self.saisie = tk.Entry(top, font=ma_police, width = 10)
        self.saisie.pack()

        self.mySubmitButton = tk.Button(top, text='OK', 
            font=ma_police, command=self.send)
        self.mySubmitButton.pack()
        self.top.grab_set()

    def send(self):
        global SAISIE
        SAISIE = (self.saisie.get())
        self.top.destroy()

def lg_crypto(ch):
    lg = 0
    for car in ch:
        if car.upper() in ALPHA:
            lg += 1
    return lg

def create_lst_chall():
    global LIST_CHALL, HEADER_CHALL
    if len(LIST_CHALL) == 0:
        lst = glob.glob("./CRYPTOS/CHALL/*.cry")
        if len(lst) == 0:
            return []

        f = open("./CRYPTOS/CHALL/HEADER.json", "r")
        HEADER_CHALL = json.load(f)
        f.close()
        if DEBUG:
            print("--- Module fenetres, create_lst_chall(): Header: ", HEADER_CHALL)    
            
        LIST_CHALL = []
        for fic in lst:
            nom_fic = fic
            f = open(nom_fic, "r")
            dico = json.load(f)
            f.close()
       
            chaine = ""
            une_ligne = []
   
            if "RESOLVED" in dico:
                if dico["RESOLVED"]:
                    chaine += "*"
                else:
                    chaine += " "
            else:
                chaine += " "
            if "NUM" in dico:
                chaine += dico["NUM"] + ". "
            else:
                return []
            if "TITLE" in dico:
                chaine += dico["TITLE"] + ". "
            chaine += "[" + str(lg_crypto(dico["CRYPTO"])) + "], "

            if "LANG" in dico:
                if dico["LANG"] in LANGUAGES:
                    chaine += LANGUAGES[dico["LANG"]] + ", "
            if "METHOD" in dico:
                chaine += dico["METHOD"] + ", "
            if "KEY_TYPE" in dico:
                chaine += dico["KEY_TYPE"] + ", "
            if "AUTHOR" in dico:
                chaine += dico["AUTHOR"]
            LIST_CHALL.append( (dico["NUM"], chaine, nom_fic))
        LIST_CHALL.sort(key=lambda x: x[0])
    return [ column[1] for column in LIST_CHALL]    

class LstChall:
    def __init__(self, parent):
        global LIST_CHALL, DICO_NEW, HEADER_CHALL
        DICO_NEW = {}
        lst = create_lst_chall()
        if len(lst) == 0:
            tkmsg.showinfo("Info", "There is no challenge")
            return
        top = self.top = tk.Toplevel(parent)
        ma_police = polices.cree_police()

        header_text = ""
        i = 0
        for cle,val in HEADER_CHALL.items():
            if cle == "TYPE":
                continue
            header_text += cle + ": " + val + "\n"
            i += 1
        self.Header = tk.Label(top, width = 50, height = i+1, font=ma_police, 
            text= header_text)
        self.Header.pack()
        self.lstPro = tk.Listbox(top, width = 50, height = 5, font=ma_police )

        for un_chall in lst:
            self.lstPro.insert(tk.END, un_chall)
        self.lstPro.pack()
        
        self.FrameButtons = tk.Frame(top)
        self.ButtonResolved = tk.Button(self.FrameButtons, text = 'Resolved',
            font=ma_police, command=self.switch_resolved)
        self.ButtonActive = tk.Button(self.FrameButtons, text = 'Active',
            font=ma_police, command=self.active)
        self.ButtonActive = tk.Button(self.FrameButtons, text = 'Active',
            font=ma_police, command=self.active)
        self.ButtonSortir = tk.Button(self.FrameButtons, text = 'Exit',
            font=ma_police, command=self.sortir)
        self.ButtonResolved.pack(side='left', expand=True, fill='both',padx='20')
        self.ButtonActive.pack(side='left', expand=True, fill='both',padx='20')
        self.ButtonSortir.pack(side='left', expand=True, fill='both',padx='20')
        self.FrameButtons.pack()
        self.top.grab_set()
        if DEBUG:
            print("--- Constructeur de LstChall: fenetre Challenge")
            
    def sortir(self):
        self.top.destroy()

    def switch_resolved(self):
        global LIST_CHALL
        try:
            idx = self.lstPro.curselection()[0]
            if DEBUG:
                print("--- LstChall.switch_resolved: Selection: ", idx)
            nom_fic = LIST_CHALL[idx][2]
            f = open(nom_fic, "r")
            dico = json.load(f)
            f.close()
            if "RESOLVED" in dico:
                if dico["RESOLVED"]:
                    dico["RESOLVED"] = False
                else:
                    dico["RESOLVED"] = True
            else:
                dico["RESOLVED"] = True
            f = open(nom_fic, "w")
            json.dump(dico, f)
            f.close()
            LIST_CHALL = []
            lst = create_lst_chall() 
            self.lstPro.delete(0,tk.END)
            for un_chall in lst:
                self.lstPro.insert(tk.END, un_chall)
        except Exception as e:
            if DEBUG:
                print("--- LstChall.switch_resolved(): EXCEPTION: ", e)
            
    def active(self):
        global DICO_NEW
        if len(self.lstPro.curselection()) == 0:
            return
        try:
            idx = self.lstPro.curselection()[0]
            DICO_NEW = json.load(open(LIST_CHALL[idx][2]))
            self.top.destroy()
        finally:
            if DEBUG:
                print("--- LstChall.active(): idx: ", idx)
                print(DICO_NEW)

class FileToDelete:
    LST_FILES = []
    def __init__(self, parent):
        global LST_FILES
        lst = []
        for fic in os.listdir("./CRYPTOS/FILES_ADDED"):
            lst.append(fic)
        lst2 = glob.glob("./CRYPTOS/CHALL/*.cry")
        if len(lst2) != 0:
            lst.append("CURRENT_CHALLENGE")
        if len(lst) == 0:
            tkmsg.showinfo("Info", "There is no file to delete")
            return
        LST_FILES = lst
        if DEBUG:    
            print("--- Constructeur de FileToDelete: LST_FILES: ", LST_FILES)
                
        top = self.top = tk.Toplevel(parent)
        ma_police = polices.cree_police()

        self.lstPro = tk.Listbox(top, width = 50, height = 5, font=ma_police );

        for a_file in lst:
            self.lstPro.insert(tk.END, a_file)
        self.lstPro.pack()

        self.FrameButtons = tk.Frame(top)
        self.ButtonDelete = tk.Button(self.FrameButtons, text = 'Delete',
            font=ma_police, command=self.delete)
        self.ButtonSortir = tk.Button(self.FrameButtons, text = 'Exit',
            font=ma_police, command=self.sortir)
        self.ButtonDelete.pack(side='left', expand=True, fill='both',padx='20')
        self.ButtonSortir.pack(side='left', expand=True, fill='both',padx='20')
        self.FrameButtons.pack()
        self.top.grab_set()
        if DEBUG:
            print("--- Constructeur de FileToDelet")
    
    def sortir(self):
        self.top.destroy()
    
    def delete(self):
        global LST_FILES
        if len(self.lstPro.curselection()) == 0:
            return
        #idx = -1
        try:
            idx = self.lstPro.curselection()[0]
            the_file = LST_FILES[idx]
            if the_file == "CURRENT_CHALLENGE":
                reponse = tkmsg.askquestion("titre", "Do you want to delete present Challenge?")
                if reponse == "yes":
                    folder = './CRYPTOS/CHALL/'
                    for filename in os.listdir(folder):
                        file_path = os.path.join(folder, filename)
                        os.remove(file_path)
            else:
                nom_fic = "./CRYPTOS/FILES_ADDED/" + the_file
                f = open(nom_fic, "r")
                lst = f.read().splitlines()
                f.close()
                if len(lst) != 0:
                    print("fic a detruire: ", lst)
                    reponse = tkmsg.askquestion("titre", "Do you want to delete files?")
                    if reponse == "yes":
                        folder = "./CRYPTOS/"
                        for fic in lst:
                            file_path = folder + fic
                            if re.search("\.cry$", file_path, re.I):
                                os.remove(file_path)
                        os.remove(nom_fic)
        finally:
            if DEBUG:
                print("--- FileToDelete.delete: LST_FILE, idx: ", LST_FILES, idx)
            self.top.destroy()
